//**************************************************************************************
// GAME base functions -----------------------------------------------------------------
//**************************************************************************************


function redrawField(grad45) {
	if (grad45==undefined) grad45=false;
	
	removeAllChilds(kivid);
	
	// tiles sizes
	var tileSize = grad45 ? tileSize2 : tileSize1;
	
	
	var xx, yy, zz=0;
	levelKivid = [];
	var zind = [];
	for (var zp = 0; zp<field.length; zp++) {
		zind = [];
		for (var yp = field[zp].length-1; yp>=0; yp--) {
			xx = grad45 ? 0 : tileSize.x*yp;
			yy = -tileSize.y*yp - tileSize.z*zp;
			zind = [];
			for (var xp = 0; xp<field[zp][yp].length; xp++) {
				
				var clp = new PIXI.Container();
				//clp.interactive = true;		   
				
				clp.position.x = Math.round(xx + (grad45 ? tileSize.w*0.55 : 0));
				clp.position.y = Math.round(yy + (grad45 ? tileSize.y : 0));
				
				clp.xx = xp;
				clp.yy = yp;
				clp.zz = zp;
				clp.tile = field[zp][yp][xp];
				
				var zzz = xp + zp*field[zp].length*field[zp][yp].length;
				zind.push({clp:clp, z:zzz});
				clp.zIndex = zzz;
				
				levelKivid.push(clp);
				
				drawTileSkin(clp, grad45);
				resetTile(clp);
				
				//if (!grad45) clp.hitArea = clp.area;
				
				kivid.addChild(clp);
				
				if (field[zp][yp][xp]==0) clp.visible = false;
				else if (ftData!=null && clp.xx==ftData.xx && clp.yy==ftData.yy && clp.zz==ftData.zz) firstTile = clp;
				xx += tileSize.x;
				if (!grad45) yy += tileSize.y;
			}
			makeSort();
		}
		makeSort();
	}
	function makeSort() {
		if (zind.length==0) return;
		zind.sort(function(a,b) {return a.z - b.z});
		for (var i = 0; i<zind.length; i++) {
			zind[i].clp.zIndex = zz;
			zz++;
		}
		zind = [];
	}
	
	
	kivid.children.sort(function(a,b) {
        a.zIndex = a.zIndex || 0;
        b.zIndex = b.zIndex || 0;
        return a.zIndex - b.zIndex;
    });
	refreshAvailables();	
	
	if (highLightMode) invisibleUnenabled();
	showSelectedPlusAutohint();
}
function refreshAvailables() {
	if (!grad45) {
		for (var i=0; i<levelKivid.length; i++) {
			if (levelKivid[i].visible && levelKivid[i].area) {
				levelKivid[i].area.buttonMode = levelKivid[i].area.interactive = checkOpen(levelKivid[i]);
			}
		}
	}
}


function showSelectedPlusAutohint() {
	if (ft1Data) kiviHighlight( getTileAt(ft1Data.xx, ft1Data.yy, ft1Data.zz), "hint");
	if (ft2Data) kiviHighlight( getTileAt(ft2Data.xx, ft2Data.yy, ft2Data.zz), "hint");
	kiviHighlight(firstTile, "pressed");
}
function kiviHighlight(kivi, type) {
	if (kivi && !grad45 && kivi.area) {
		type = typeof type !== 'undefined' ? type : '';
		
		if (type=="over") {kivi.area.alpha = 0.18;}
		else if (type=='active' || type=='pressed') {
			kivi.highligted = true;
			kivi.area.alpha = 0.7;
			kivi.hintarea.alpha = 0;
			
			if (tutorialStep==1 && kivi.bmp) kivi.bmp.tint = 0xffffff;
		}
		else if (type=='hint') {
			kivi.highligted = true;
			kivi.area.alpha = 0;
			kivi.hintarea.alpha = 0.7;
		}
		else {
			// reset highlighting
			kivi.highligted = false;
			kivi.area.alpha = 0;
			kivi.hintarea.alpha = 0;
			kivi.hintarea.tint = 0xffffff;
			
			if (tutorialStep==1 && kivi.bmp) kivi.bmp.tint = checkOpen(kivi) ? 0xc9ffbb : 0xffc6d3;
		}
	}
}
function drawTileSkin(tile, grad45) {
	if (grad45==undefined) grad45=false;
	
	removeAllChilds(tile);
	var bmp;
	
	if (isTournament && tile.tile==999) {
		bmp = getAsset(grad45 ? (tournament_type ? 'babyDragon_rot' : "dragontile_front") : (tournament_type ? 'babyDragon' : "goldDragon2"), tileSize.w);
		bmp.anchor.x = bmp.anchor.y = 0;
		bmp.interactive = false;
		tile.addChild(bmp);
	}
	else if (tile.tile==999) {
		bmp = getAsset(grad45 ? "kub_front" : "kub", tileSize.w); // new tileset for 45 grad!
		bmp.anchor.x = bmp.anchor.y = 0;
		tile.addChild(bmp);
		
		// add friend bitmaps
		/*var frSkin = new PIXI.Sprite.fromImage(helpFriend);
		if (frSkin.texture.baseTexture.hasLoaded==true) picLoaded();
		else frSkin.texture.baseTexture.on('loaded', picLoaded).on('error', function() {
			helpFriend='defaultThumb'; picLoaded();
		});
		function picLoaded() {
			frSkin.position.x = bmp.width/5.5;
			frSkin.position.y = bmp.height*0.27;
			frSkin.width = bmp.width*0.64;
			frSkin.scale.y = frSkin.scale.x;
			
			if (!grad45) {
				var frSkin2 = new PIXI.Sprite.fromImage(helpFriend);
				frSkin.skew.y = 0.176;
				frSkin2.skew.y = -0.176;
				frSkin.position.x = bmp.width * 0.054;
				frSkin2.position.x = bmp.width * 0.513;
				frSkin.width = frSkin2.width = bmp.width*0.44;
				frSkin.height = frSkin2.height = bmp.height*0.59;
				frSkin.position.y = bmp.height * 0.205;
				frSkin2.position.y = bmp.height * 0.31;
				tile.addChild(frSkin2);
			}
			frSkin.interactive = false;
			tile.addChild(frSkin);
		}*/
		
	} else {
		bmp = new PIXI.Sprite(grad45 ? allTiles.resources['tileSkin'+curTileId+'_'+tile.tile+'_2'].texture : allTiles.resources['tileSkin'+curTileId+'_'+tile.tile].texture);
		bmp.interactive = false;
		tile.addChild(bmp);	
	}
	
	if (!grad45) {
		tile.hintboosterArea = new PIXI.Graphics();
		tile.hintboosterArea.beginFill(0xedfcff, 0.7);
		tile.hintboosterArea.moveTo(tileSize.w/1.9, tileSize.w/14);
		tile.hintboosterArea.lineTo(tileSize.w*0.97, tileSize.w/5.8);
		tile.hintboosterArea.lineTo(tileSize.w*0.97,tileSize.w*0.85);
		tile.hintboosterArea.lineTo(tileSize.w/1.95,tileSize.w*0.95);
		tile.hintboosterArea.lineTo(tileSize.w/26, tileSize.w*0.83);
		tile.hintboosterArea.lineTo(tileSize.w/26, tileSize.w/5.9);
		tile.hintboosterArea.lineTo(tileSize.w/2, tileSize.w/14);
		tile.hintboosterArea.endFill();
		tile.addChild(tile.hintboosterArea);
		
		// add tile area
		tile.area = new PIXI.Graphics();
		tile.area.beginFill(0x00d7ff, 0.75);
		tile.area.moveTo(tileSize.w/1.9, tileSize.w/15);
		tile.area.lineTo(tileSize.w*0.97, tileSize.w/5.9);
		tile.area.lineTo(tileSize.w*0.97,tileSize.w*0.85);
		tile.area.lineTo(tileSize.w/1.95,tileSize.w*0.95);
		tile.area.lineTo(tileSize.w/26, tileSize.w*0.85);
		tile.area.lineTo(tileSize.w/26, tileSize.w/5.9);
		tile.area.lineTo(tileSize.w/2, tileSize.w/15);
		tile.area.endFill();
		tile.addChild(tile.area);
		tile.area.alpha = 0;
		tile.area.interactive = true;
		tile.area.on("mousedown", prs).on("touchstart", prs).on('mouseover', kiviCanPress).on('mouseout', kiviReset);
		// add hintarea
		tile.hintarea = new PIXI.Graphics();
		tile.hintarea.beginFill(0xbaef00, 0.75);  
		tile.hintarea.moveTo(tileSize.w/1.9, tileSize.w/15);
		tile.hintarea.lineTo(tileSize.w*0.97, tileSize.w/5.9);
		tile.hintarea.lineTo(tileSize.w*0.97,tileSize.w*0.85);
		tile.hintarea.lineTo(tileSize.w/1.95,tileSize.w*0.95);
		tile.hintarea.lineTo(tileSize.w/26, tileSize.w*0.85);
		tile.hintarea.lineTo(tileSize.w/26, tileSize.w/5.9);
		tile.hintarea.lineTo(tileSize.w/2, tileSize.w/15);
		tile.hintarea.alpha = 0;
		tile.hintarea.endFill();
		tile.addChild(tile.hintarea);
	} else {
		tile.hintboosterArea = new PIXI.Graphics();
		tile.hintboosterArea.beginFill(0xedfcff, 0.7);
		tile.hintboosterArea.drawRect(tileSize.w*0.16, tileSize.w*0.09, tileSize.w*0.7, tileSize.w*0.82);
		tile.hintboosterArea.endFill();
		tile.addChild(tile.hintboosterArea);
	}
	tile.hintboosterArea.visible = highLightMode && checkOpen(tile);
	if (tutorialStep==1) {tile.bmp = bmp; bmp.tint = checkOpen(tile) ? 0xc9ffbb : 0xffc6d3;}
}
function resetActives() {
	if (ft1Data) resetTile( getTileAt(ft1Data.xx, ft1Data.yy, ft1Data.zz) );
	if (ft2Data) resetTile( getTileAt(ft2Data.xx, ft2Data.yy, ft2Data.zz) );
	ft1Data = null;
	ft2Data = null;	
	unblinkArrow(bl);
	unblinkArrow(br);
}
function resetTile(tl) {
	if (tl) kiviHighlight(tl, '');
}
function checkOpen(clp) {
	if (!clp) return false;
	var xxClosed = clp.xx>0 && clp.xx<field[clp.zz][clp.yy].length-1 && field[clp.zz][clp.yy][clp.xx-1]!=0 && field[clp.zz][clp.yy][clp.xx+1]!=0;
	var yyClosed = clp.yy>0 && clp.yy<field[clp.zz].length-1 && field[clp.zz][clp.yy-1][clp.xx]!=0 && field[clp.zz][clp.yy+1][clp.xx]!=0;
	//var zzClosed = clp.zz>0 && clp.zz<field.length-1 && field[clp.zz-1][clp.yy][clp.xx]!=0 && field[clp.zz+1][clp.yy][clp.xx]!=0;
	return !(xxClosed || yyClosed); // || zzClosed
}
function disableAutoHightlighting() {
	disableHightlighting();
	lastPartTime = levelTime;
}
function disableHightlighting() {
	for (var i=0; i<levelKivid.length; i++) {
		if (levelKivid[i].visible) resetTile(levelKivid[i]);
	}
}
function rotField() {
	// rotate array data
	var newField = [];
	for (var zp = 0; zp<field.length; zp++) {
		var arr = [];
		for (var n = 0; n<field[zp][0].length; n++) {
			var arr2 = [];
			for (var q = 0; q<field[zp].length; q++) {
				arr2.push(field[zp][q][n]);
			}
			arr.push(arr2.reverse());
		}
		newField.push(arr);
	}
	field = newField;
}
function convertXY(x1, y1, rot) {
	// rotate x y
	var xx = rot==90 ? y1 : field[0].length-1 - y1;
	var yy = rot==90 ? field[0][0].length-1 - x1 : x1;
	return {xx:xx, yy:yy};
}
function havePair() {
	// check have one pair available
	for (var i = 0; i<levelKivid.length; i++) {
		var clp1 = levelKivid[i];
		if (clp1.visible && checkOpen(clp1)) {
			for (var z = 0; z<levelKivid.length; z++) {
				var clp2 = levelKivid[z];
				if (clp2.visible && clp1!=clp2 && clp1.tile == clp2.tile && checkOpen(clp2)) return true;
			}
		}
	}
	return false;
}
function rotR() {
	rotating = true;
	clearTimeout(autoCollectTimeout);
	
	gameRotation -= 90;
	if (gameRotation<0) gameRotation+=360;
	
	// ring temporary invisile. Remove when not needed...
	//TweenLite.to(ring.ring, 0.45, {rotation:'-=90', onComplete:function():void {ring.ring.rotation = gameRotation+45;}});
	var tmp;
	if (ftData) {
		tmp = convertXY(ftData.xx, ftData.yy, -90);
		ftData.xx = tmp.xx; ftData.yy = tmp.yy;
	}
	if (ft1Data) {
		tmp = convertXY(ft1Data.xx, ft1Data.yy, -90);
		ft1Data.xx = tmp.xx; ft1Data.yy = tmp.yy;
	}
	if (ft2Data) {
		tmp = convertXY(ft2Data.xx, ft2Data.yy, -90);
		ft2Data.xx = tmp.xx; ft2Data.yy = tmp.yy;
	}
	removeAllChilds(kivid);
	rotField();
	redrawField(true);
	
	setTimeout(function() {
		removeAllChilds(kivid);
		redrawField();
		blinkArrows();
		rotating = false;
		if (autoplaying) nextAutoCollect();
	}, 85);
	
	if (tutorialStep!=0) tutorial.refreshTileColors();
}
function rotL() {
	rotating = true;
	clearTimeout(autoCollectTimeout);
	
	gameRotation += 90;
	if (gameRotation==360) gameRotation=0;
	//TweenLite.to(ring.ring, 0.45, {rotation:'+=90', onComplete:function():void {ring.ring.rotation = gameRotation+45;}});
	var tmp;
	if (ftData) {
		tmp = convertXY(ftData.xx, ftData.yy, 90);
		ftData.xx = tmp.xx; ftData.yy = tmp.yy;
	}
	if (ft1Data) {
		tmp = convertXY(ft1Data.xx, ft1Data.yy, 90);
		ft1Data.xx = tmp.xx; ft1Data.yy = tmp.yy;
	}
	if (ft2Data) {
		tmp = convertXY(ft2Data.xx, ft2Data.yy, 90);
		ft2Data.xx = tmp.xx; ft2Data.yy = tmp.yy;
	}

	removeAllChilds(kivid);
	rotField();
	rotField();
	rotField();
	redrawField(true);
	setTimeout(function() {
		removeAllChilds(kivid);
		redrawField();
		blinkArrows();
		rotating = false;
		if (autoplaying) nextAutoCollect();
	}, 85);
	
	if (tutorialStep!=0) tutorial.refreshTileColors();
}
function getTileAt(xx, yy, zz) {
	for (var i=0; i<levelKivid.length; i++) {
		if (levelKivid[i].visible && levelKivid[i].xx==xx && levelKivid[i].yy==yy && levelKivid[i].zz==zz) return levelKivid[i];
	}
	return null;
}








var firstTilePressed = false;
function collectTiles(kivi1, kivi2) {
	var starsWas = tutorialStep==1 ? 0 : starsCollected();
	
	// remove
	field[kivi1.zz][kivi1.yy][kivi1.xx] = field[kivi2.zz][kivi2.yy][kivi2.xx] = 0;
	
	if (kivi1.area) kivi1.area.interactive = false;
	if (kivi2.area) kivi2.area.interactive = false;
	kivi1.visible = kivi2.visible = false;
	
	// add animation
	if (renderer.type!=2 && !autoCollect) {
		var sheet = getSheet('tileExplose');
		sheet.alpha = 0.6;
		makeSheet(sheet, stageW*0.14, false, 0.5, kivi2.position.x + kivi2.width/2, kivi2.position.y + kivi2.height/2, 0, true);
		kivid.addChild(sheet);
	}
	
	playSound('kivi_pair');
	
	levelScore += pairScore;
	turns++;
	turns3++;
	
	//log(turns3+'/'+totalTiles3);
	
	//if (!clock && tutorialStep==0 && !canTouch) disconnect('Wrong data error');
	
	// ten pairs
	if (turns%10==0 && !isTournament) {
		levelScore += levelTime;
		timeScore += levelTime;
		// add score sheet
		var blinkScore = getSheet('tileExplose');
		makeSheet(blinkScore, stageW*0.19, false, 0.5, stageW*0.225, stageH*0.05, 0, true);
		stage.addChild(blinkScore);
		
		// 10 pairs animation clip on score
		var p10 = createText(xmlValue('tenPairs').replace('[number]', turns3), {fontSize:20, color:'#ffffff'});
		p10.position.x = stageW*0.242;
		p10.position.y = stageH*0.057;
		TweenLite.to(p10, 0.7, {y:'+='+(stageH*0.06), alpha:0, onComplete:function() { stage.removeChild(p10); }});
		stage.addChild(p10);
	}
	
	// FRIEND PAIR
	if (kivi1.tile==999) {
		playSound('friendTimeBonus');
		friendTilePairsCollected++;
		
		if (!isTournament) {
			if (haveFrinedBoost==1) haveFrinedBoost = -1; // can invite (haveFrinedBoost=1), invited now (haveFrinedBoost=-1).
			
			levelTime += isChallenge ? -10 : 10;
			levelTimeStart += isChallenge ? 0 : 10;
			lastPartTime = levelTime;
			updateTopClock();  // moved to plus15Sec clip (to have some waiting till user see)
			
			// +10 sec animation clip on friend tile
			var mc = createText('+10sec', {fontSize:21, color:'#ffffff'});
			mc.position.x = kivi2.x + kivid.position.x;
			mc.position.y = kivi2.y + kivid.position.y;
			TweenLite.to(mc, 0.7, {y:'-='+(stageH*0.06), alpha:0, onComplete:function() { stage.removeChild(mc);}});
			stage.addChild(mc);
			
			// +15 sec animation clip on timer
			var mct = createText('+10sec', {fontSize:20, color:'#ffffff'});
			mct.position.x = stageW*0.293;
			mct.position.y = stageH*0.06;
			TweenLite.to(mct, 0.7, {y:'+='+(stageH*0.06), alpha:0, onComplete:function() { stage.removeChild(mct); }});
			stage.addChild(mct);
			
			
			if (isChallenge) {
				elements.placeChallengeCoins();
				challengeSlider();
			}
			
		} else {
			thisLevDragons++;
			removeKivi(kivi1, false);
			removeKivi(kivi2, true);
		}
	}
	
	
	
	var tmp;
	if (ft1Data) {
		tmp = getTileAt(ft1Data.xx, ft1Data.yy, ft1Data.zz);
		if (tmp == kivi1 || tmp == kivi2) ft1Data = null;
	}
	if (ft2Data) {
		tmp = getTileAt(ft2Data.xx, ft2Data.yy, ft2Data.zz);
		if (tmp == kivi1 || tmp == kivi2) ft2Data = null;
	}
	
	if (!isChallenge && !isTournament && tutorialStep!=1) {
		var ww = pairWidth*turns3;
		if (starsCollected()==3) {
			setSlider(progressSliderStartWidth); 
			animateStar(elements.star3);
			if (starsWas<2) animateStar(elements.star2);
		} else TweenLite.to(elements.progressSlider, 0.4, {width:ww});
	}
	
	// first star time statistics for challenge
	if (isChallenge && firstStarTime==0 && starsCollected()>0) {
		firstStarTime = levelTime + friendTilePairsCollected*10;
		if (threeInOneLevel) firstStarTime += arraySum(completedTimes);
		//log("GOT FIRST STAR");
	}
	
	// have first star / animate top stars when completed.
	if (tutorialStep!=1 && !isChallenge && !isTournament) {
		if (starsWas==0 && starsCollected()==1) {
			//help2But.visible = false;
			animateStar(elements.star1);
			playSound('firstStar');
			firstStarTime = levelTimeStart-levelTime;
			if (threeInOneLevel) firstStarTime += arraySum(completedTimes);
		}
		if (starsWas<2 && starsCollected()==2) {
			if (starsWas==0) animateStar(elements.star1);
			animateStar(elements.star2);
		}
	}
	resetActives();
	
	if (elements) updateTxt(elements.t_levscore, levelScore);
	
	// tutorial
	if (tutorialStep!=0) {
		tutorial.refreshTileColors();
		if (tutorialStep==1) tutorial.step3(kivi2.tile);
	}
	// tutorial advanced
	else if (mapDATA && mapDATA[1].stars==0 && turns==1) {
		analytics('/api/analytics?code=tutorialStep_10');
	}
	
	
	//if (threeInOneLevel) log('3COLLECT:'+turns+'/'+totalTiles+'ofAll'+turns3+'/'+totalTiles3+'.'); else log('COLLECT:'+turns+'/'+totalTiles+'.');
	
	// autoshuffle
	if (!havePair() && turns*2<totalTiles) {
		analytics('/api/usebooster?action=autoShuffle&completePercent='+(turns3*2 / totalTiles3 * 100));
		shuffle('auto');
	}
	
	
	refreshAvailables();
	if (highLightMode) invisibleUnenabled();
	
	

	if (turns*2==totalTiles || isTournament && dragonCount==friendTilePairsCollected*2 && !askedRepeatPopup || isTournament && !tournament_try100percent && dragonCnt==thisLevDragons*2 && fields.length>0) {
		clockStop();
		setTimeout(finishLevel, 30);
	} // winner!
	firstTilePressed = false;
	
	if (isTournament && tournRepeatBut && fields.length>0) {
		//log(dragonCnt+'=='+(thisLevDragons*2));
		if (dragonCnt==thisLevDragons*2 && tournRepeatBut.mode=='disabled' && tournament_try100percent && turns<totalTiles/2) {
			tournRepeatBut.enable();
			var stars = getSheet('starsExplose');
			makeSheet(stars, stageH*0.3, false, 0.5, tournRepeatBut.position.x + tournRepeatBut.w*0.7/2, tournRepeatBut.position.y + tournRepeatBut.h*0.7/2, 200, true);
			GAME.addChild(stars);
			blinkBut(tournRepeatBut,3);
			
			if (!tournamentSkipLevTutorial) tournamentSkipLevTutorialF();
			if (autoplaying && Math.random()<0.5 && turns*2<totalTiles-4) proceedTournament();
		}
		var txt = xmlValue('tournTimeBonus');
		updateTxt(tournTilesCollectTxt, txt.replace('[time]', turns*2));
	}
	
	// autocollect
	if (autoCollect && !havePopups) nextAutoCollect();
}
function prs() {
	
	if (canTouch) {
		disableAutoHightlighting();
		
		var prsmc = this.parent;
		if (firstTile && firstTile.visible && firstTilePressed) {
			secondTile = prsmc;
			// check pair
			
			if (firstTile!=secondTile && firstTile.visible && secondTile.visible && firstTile.tile == secondTile.tile && checkOpen(firstTile) && checkOpen(secondTile)) {
				
				collectTiles(firstTile, secondTile);
				
			} else {
				// reset
				if (checkOpen(prsmc)) {
					if (ft1Data && ft2Data && prsmc!=getTileAt(ft1Data.xx, ft1Data.yy, ft1Data.zz) && prsmc!=getTileAt(ft2Data.xx, ft2Data.yy, ft2Data.zz)) resetActives();
					firstTile = prsmc;
					firstTilePressed = true;
					kiviHighlight(firstTile, 'pressed');
					playSound('kivi_click');
					blinkArrows();
				}
			}
		} else if (checkOpen(prsmc)) {
			//resetActives();
			firstTile = prsmc;
			firstTilePressed = true;
			kiviHighlight(firstTile, 'pressed');
			playSound('kivi_click');
		}
		ftData = firstTile ? {xx:firstTile.xx, yy:firstTile.yy, zz:firstTile.zz} : null;
		lastPartTime = levelTime*1; //10 sec hint from new levelTime
		
		if (highLightMode) invisibleUnenabled();
		showSelectedPlusAutohint();
	}
}
function removeKivi(clp, both) {
	if (kivid) {
		// fly up.
		var fly = getAsset(tournament_type ? 'babyDragon' : 'goldDragon2', kH);
		fly.position.x = clp.position.x + kivid.position.x;
		fly.position.y = clp.position.y + kivid.position.y;
		fly.anchor.x = fly.anchor.y = 0.5;
		clp.visible = false;
		
		stage.addChild(fly);
		// maybe rotate and resize as second asset?
		TweenLite.to(fly, 0.4, {x:elements.dragon.position.x, y:elements.dragon.position.y, onComplete:function() {
			// ok, collected dragon flyed up...
			stage.removeChild(fly);
			
			// renew t_dr text
			if (elements.t_dr) {
				elements.removeChild(elements.t_dr);
				elements.t_dr = createText((friendTilePairsCollected*2) + ' / '+dragonCount+'   <yellow>'+(thisLevDragons*2)+' / '+dragonCnt+'</yellow>', {fontSize:22, x:elements.dragon.position.x + elements.dragon.width*0.8, align:"left", y:elements.dragon.position.y, width:stageW*0.44});
				elements.t_dr.anchor.x = 0;
				elements.addChild(elements.t_dr);
			}
			if (both) {
				// add stars blink
				var sheet = getSheet('tileExplose');
				makeSheet(sheet, stageW*0.103, false, 0.5, elements.dragon.position.x, elements.dragon.position.y, 0, true);
				stage.addChild(sheet);
			}
			if (clp && kivid) kivid.removeChild(clp);
			if (levelKivid.indexOf(clp)>=0) levelKivid.splice(levelKivid.indexOf(clp),1);
			clp = null;
		}});
		setTimeout(function() {if (both) firstTile=null;}, 4);
	}
}











function kiviCanPress() {
	if (!havePopups) {
		var kivi = this.parent;
		if (kivi.visible && checkOpen(kivi) && kivi!=firstTile) {
			kivi.area.visible = true;
			kiviHighlight(kivi, 'over');
		}
	}
}
function kiviReset() {
	var kivi = this.parent;
	if (kivi && kivi.visible && checkOpen(kivi) && kivi!=firstTile) {
		kiviHighlight(kivi, kivi.highligted ? 'hint' : '');
	}
}


function checkMoreStars() {
	return !isChallenge && tutorialStep==0 && starsWas>0 && totalTiles3-turns3*2>0;	
}
function starsCollected() {
	if (isTournament) return 0;
	if (turns3*2 == totalTiles3) return 3;
	else if (turns3*2 / totalTiles3 >= star_percent[1]/100) return 2;
	else if (turns3*2 / totalTiles3 >= star_percent[0]/100) return 1;
	else return 0;
}


// shuffle elements *******************************************************************
function shuffle(arg) {
	canTouch = false;
	autoCollect = false;
	//reset active
	resetTile(firstTile);
	firstTilePressed = false;
	
	disableAutoHightlighting();
	resetActives();
	
	var i, nr, newArr = [], was = [];
	for (var zp = 0; zp<field.length; zp++) {
		for (var yp = 0; yp<field[zp].length; yp++) {
			for (var xp = 0; xp<field[zp][yp].length; xp++) {
				if (field[zp][yp][xp]!=0) was.push(field[zp][yp][xp]);
			}
		}
	}
	if (elements) elements.addNotouch();
	if (arg=='start') {
		// tiles in one current level
		totalTiles = was.length;
	
		var tileReplacedByFriend = -1;
		var countFriends = 0;
		var maxCount = 2;
		if (was.length<=120) maxCount = 1;
		
		if (isTournament) {
			var dragonCnt12 = parseInt(dragonCount/4);
			if (dragonCnt12%2!=0) dragonCnt12++;
			if (dragonCnt12>was.length && fields.length>0) dragonCnt12 = was.length;
			var dragonCnt3 = dragonCount - dragonCnt12*2;
			if (dragonCnt3>was.length && fields.length==0) dragonCnt3 = was.length;
			maxCount = fields.length>0 ? dragonCnt12 : dragonCnt3;
			dragonCnt = maxCount; // just this level dragons to collect
			thisLevDragons = 0; // collected on just this level
			log('dragonCount='+dragonCount);
			log('counts:  '+dragonCnt12+'|'+dragonCnt12+'|'+dragonCnt3);
			dragonCount = dragonCnt12*2 + dragonCnt3;
			
			log('max count on this lev part:   '+dragonCnt);
			updateTxt(elements.t_dr, (friendTilePairsCollected*2)+' / '+dragonCount+'   <yellow>0 / '+dragonCnt+'</yellow>');
		}
		if (levelMaxRandoms < 3) levelMaxRandoms = 18;
		for (i = 0; i<was.length; i+=2) {
			nr = parseInt(Math.random()*levelMaxRandoms)+1;
			
			if (!isTournament && tileReplacedByFriend==-1 && tutorialStep!=1) tileReplacedByFriend = nr;
			
			if (nr == tileReplacedByFriend && helpFriend && countFriends<maxCount/2   || isTournament && countFriends<maxCount/2) {
				countFriends++;
				nr = 999;
			}
			newArr.push(nr);
			newArr.push(nr);
		}
		was = newArr;
		repeatShuffle(newArr);
	} else {
		if (elements && elements.boosters && elements.boosters.shuffleBut) elements.boosters.shuffleBut.disable();
		clockStop();
		
		// animate
		playSound('animateLevel');
		analytics('/api/usebooster?action=autoShuffle&completePercent='+(turns*200/totalTiles));
		
		for (i = 0; i<levelKivid.length; i++) {
			var xx = 0, yy = 0;
			xx = parseInt(Math.random()*stageW*0.4) * (Math.random()<0.5 ? -1 : 1);
			yy = parseInt(Math.random()*stageH*0.4) * (Math.random()<0.5 ? -1 : 1);
			if (levelKivid[i].visible) moving(levelKivid[i], xx, yy);
		}
		setTimeout(repeatShuffle, 400);
	}
	function moving(ant, xx, yy) {
		ant.hintboosterArea.visible = false;
		TweenLite.to(ant, 0.4, {x:'+='+xx, y:'+='+yy, onComplete:function() {
			TweenLite.to(ant, 0.4, {x:'-='+xx, y:'-='+yy, onComplete:function() {
				ant.position.x = Math.round(ant.position.x);
				ant.position.y = Math.round(ant.position.y);
			}});
		}});
	}
	function repeatShuffle(arr) {
		
		var elm = [];
		var i;
		var elm2 = [];
		
		
		// randomize images

		for (i=0; i<levelKivid.length; i++) {
			if (levelKivid[i].visible && field[levelKivid[i].zz][levelKivid[i].yy][levelKivid[i].xx]!=0) elm.push(levelKivid[i]);
		}
		for (i=0; i<elm.length; i++) elm2.push(arr ? arr[i] : elm[i].tile);
		
		var totalLeft = elm.length;
		elm2 = actualShuffle(elm2);
		makeFieldsOfTiles(elm2);
		var checkedKivid = [];
		
		if (tutorialStep==0) {
			// intilligence
			var availableKivid = [];
			for (var t=0; t<totalLeft; t+=2) {
				var checkedPair = [];
				
				elm = actualShuffle(elm);
				makeFieldsOfTiles(elm2);
				
				for (i=totalLeft-1; i>=0; i--) {
					if (elm[i] && elm[i].visible && checkOpen(elm[i]) && checkedPair.indexOf(elm[i])<0) {
						checkedPair.push(elm[i]);
						if (checkedPair.length==2) {
							checkedPair[0].visible = checkedPair[1].visible = false;
							field[checkedPair[0].zz][checkedPair[0].yy][checkedPair[0].xx] = field[checkedPair[1].zz][checkedPair[1].yy][checkedPair[1].xx] = 0;
							checkedKivid.push(checkedPair[0]);
							checkedKivid.push(checkedPair[1]);
							break;
						}
					}
				}
				if (checkedKivid.length==14) break; // 7 pairs always are playable
			}
			if (checkedKivid.length%2!=0) {
				var lastK = checkedKivid.pop();
				lastK.visible = true;
			}
			log('shuffle arg='+arg);
			
			// set top 10 kivid
			var rnd,r1;
			for (i=0; i<checkedKivid.length; i+=2) {
				rnd = elm2.shift();
				elm2.splice(elm2.indexOf(rnd), 1);
				checkedKivid[i].tile = rnd;
				checkedKivid[i+1].tile = rnd;
				checkedKivid[i].visible = checkedKivid[i+1].visible = true;
				field[checkedKivid[i].zz][checkedKivid[i].yy][checkedKivid[i].xx] = field[checkedKivid[i+1].zz][checkedKivid[i+1].yy][checkedKivid[i+1].xx] = rnd;
			}
		}

		
		// other kivid
		for (i=0; i<totalLeft; i++) {
			if (checkedKivid.indexOf(elm[i])<0 && field[elm[i].zz][elm[i].yy][elm[i].xx]!=0) {
				elm[i].tile = elm2.shift();
				field[elm[i].zz][elm[i].yy][elm[i].xx] = elm[i].tile;
			}
		}
		for (i=0; i<totalLeft; i++) {
			drawTileSkin(elm[i], false);
			elm[i].hintboosterArea.visible = false;
		}
		elm = elm2 = checkedKivid = checkedPair = null;
		setTimeout(function() {
			// end shuffle
			if (elements) {
				if (elements.boosters && elements.boosters.shuffleBut) {elements.boosters.shuffleBut.enable();}
				elements.removeNotouch();
			}
			
			refreshAvailables();
			if (highLightMode) invisibleUnenabled();
			
			// avoid repeat clock in drop animation (rain)
			if (arg!='start') {
				repeatClock();
				canTouch = true;
				if (autoplaying) autoCollect=true;
				if (autoCollect) nextAutoCollect();
			}
			
			if (arg=='auto') shufflesInGame++;
		}, 400);
	}
	function actualShuffle(arr) {
		var arr2 = [];
		while (arr.length>0) {
			nr = parseInt(Math.random()*arr.length);
			arr2.push(arr[nr]);
			arr.splice(nr,1);
		}
		arr = null;
		return arr2;
	}
	function makeFieldsOfTiles(arr) {
		for (var i=0; i<arr.length; i++) {if (arr[i] && arr[i].visible && field[arr[i].zz][arr[i].yy][arr[i].xx]!=0) field[arr[i].zz][arr[i].yy][arr[i].xx] = arr[i].tile;}
	}
}









function blinkArrows() {
	unblinkArrow(bl);
	unblinkArrow(br);
	if (ft2Data && ft1Data && tutorialStep==0) {
		var hint1 = getTileAt(ft1Data.xx, ft1Data.yy, ft1Data.zz);
		var hint2 = getTileAt(ft2Data.xx, ft2Data.yy, ft2Data.zz);
		if (hint1 && hint2) {
			var yep1 = true, yep2 = true;
			var mc_front1 = getTileAt(ft1Data.xx+1, ft1Data.yy-1, ft1Data.zz);
			var mc_front2 = getTileAt(ft1Data.xx+2, ft1Data.yy-2, ft1Data.zz);
			var mc_front3 = getTileAt(ft1Data.xx+2, ft1Data.yy-2, ft1Data.zz+1);
			if (firstTile && firstTile==hint1 || secondTile && secondTile==hint1) yep1 = false;
			
			var mc_front4 = getTileAt(ft2Data.xx+1, ft2Data.yy-1, ft2Data.zz);
			var mc_front5 = getTileAt(ft2Data.xx+2, ft2Data.yy-2, ft2Data.zz);
			var mc_front6 = getTileAt(ft2Data.xx+2, ft2Data.yy-2, ft2Data.zz+1);
			if (firstTile && firstTile==hint2 || secondTile && secondTile==hint2) yep2 = false;
			
			if (mc_front1 && mc_front1.visible && yep1 || mc_front2 && mc_front2.visible && yep1 || mc_front3 && mc_front3.visible && yep1 || 
				mc_front4 && mc_front4.visible && yep2 || mc_front5 && mc_front5.visible && yep2 || mc_front6 && mc_front6.visible && yep2) {
				//field[z][y][x]
				var centerX = stageW/2;
				if (hint1 && hint2) {
					if (hint1.position.x+kivid.position.x < centerX && hint2.position.x+kivid.position.x < centerX) blinkArrow(br); else blinkArrow(bl);
				}
				else if (hint1) {
					if (hint1.position.x+kivid.position.x < centerX) blinkArrow(br); else blinkArrow(bl);
				}
				else if (hint2) {
					if (hint2.position.x+kivid.position.x < centerX) blinkArrow(br); else blinkArrow(bl);
				}
			}
		}
	}
}
function blinkArrow(ar) {
	if (ar && ar.glow) {
		TweenLite.to(ar.glow, 0.44, {alpha:1, onComplete:function() {
			TweenLite.to(ar.glow, 0.44, {alpha:0, onComplete:function() {blinkArrow(ar);}});
		}});
	}
}
function unblinkArrow(ar) {
	if (ar && ar.glow) {
		TweenLite.killTweensOf(ar.glow);
		ar.glow.alpha = 0;
	}
}
function addTime201(additionalTime) {
	
	if (isTournament && tournRepeatBut && tournament_try100percent) tournRepeatBut.disable();
	
	completedTimes.push(totalTime3);
	totalTime3=0; //???
	
	stopMusic();
	hideHint();
	clockStop();
	
	canTouch = false;
	
	// next lev data
	var newLevTime = levelTimes.shift()*1;
	levelTime = newLevTime + additionalTime;
	levelTimeStart = lastPartTime = levelTime*1;
	
	field = (fields.shift()).field;
	if (maxTiles.length>0) {
		levelMaxRandoms = maxTiles.shift()*1;
		levelMaxRandoms--;
		if (levelMaxRandoms > allTiles.length) levelMaxRandoms = allTiles.length;
	}
	if (levelMaxRandoms < 3) levelMaxRandoms = 18;
	if (GAME && GAME.but_tmp) GAME.but_tmp.visible = false;
	
	
	// add 3 lev additional times glow clips
	addTimClp = new PIXI.Container();
	// add glow
	var glow = getAsset('glow', stageW*0.8);
	glow.anchor.x = glow.anchor.y = 0.5;
	glow.position.x = stageW/2;
	glow.position.y = stageH/2;
	glow.alpha = 0;
	glow.width = glow.height = stageW*0.1;
	addTimClp.addChild(glow);
	var si = setInterval(function() {
		glow.rotation += 0.01;
	}, 10);
	TweenLite.to(glow, 0.5, {width:stageW*0.8, height:stageW*0.8, alpha:1});
	var txt = createText(additionalTime+'sec', {fontSize:50, x:0, y:stageH/2});
	txt.anchor.x = 0;
	txt.position.x = stageW/2 - txt.width/2;
	addTimClp.addChild(txt);
	stage.addChild(addTimClp);
	
	setTimeout(function() {
		var txt2 = createText('+ '+newLevTime+'sec', {fontSize:50, x:txt.position.x + txt.width + 5, y:txt.position.y});
		txt2.alpha = 0;
		addTimClp.addChild(txt2);
		var ww = txt2.width + txt.width + 5;		
		TweenLite.to(txt, 0.3, {x:stageW/2 - ww/2});
		TweenLite.to(txt2, 0.4, {alpha:1});
		setTimeout(function() {
			TweenLite.to(txt, 0.3, {y:'+=20', alpha:0});
			TweenLite.to(txt2, 0.3, {y:'+=20', alpha:0});
			TweenLite.to(glow, 0.3, {width:stageW*0.2, height:stageW*0.2, alpha:0, onComplete:function() {
				clearInterval(si);
				addTimClp.destroy();
				stage.removeChild(addTimClp);
				addTimClp = null;
				nextLevel201();
			}});
		}, 1600);
	}, 600);
	
}
function nextLevel201() {
	
	if (kivid) {kivid.destroy(); kivid = null;}
	firstTile = secondTile = null;
	if (!kivid) {
		kivid = new PIXI.Container();
		gameContainer.addChild(kivid);
	}
	kivid.position.x = parseInt(stageW*0.5 - (field[0].length*tileSize.x + field[0][0].length*tileSize.x)/2); //!!!
	kivid.position.y = parseInt(stageH*0.53 - (field[0][0].length*tileSize.y + field[0].length*tileSize.y)/2) + Math.round(field.length/2)*tileSize.z;
	if (isTournament) kivid.position.y -= 20;
	
	redrawField();
	shuffle('start');
	
	if (isTournament && tournRepeatBut) {
		thisLevDragons = 0;
		if (fields.length==0) removeTournRepeatButton(); else {
			tournRepeatBut.disable();
			var txt = xmlValue('tournTimeBonus');
			updateTxt(tournTilesCollectTxt, txt.replace('[time]', 0));
		}
	}
	
	for (var zz = 0; zz<field.length; zz++) {
		for (var yy = field[zz].length-1; yy>=0; yy--) {
			for (var xx = 0; xx<field[zz][yy].length; xx++) {
				var clp = getTileAt(xx,yy,zz);
				if (clp) clp.position.y -= stageH;
			}
		}
	}
		
	var wt = setInterval(rain, 60);
	function rain() {
		var found = false;
		for (var zz = 0; zz<field.length; zz++) {
			for (var yy = field[zz].length-1; yy>=0; yy--) {
				for (var xx = 0; xx<field[zz][yy].length; xx++) {
					var clp = getTileAt(xx,yy,zz);
					if (clp && !clp.drop) {
						clp.drop = true;
						found = true;
						TweenLite.to(clp, 0.12 + Math.random()*0.12, {y:'+='+stageH});
					}
				}
				if (found) return;
			}
		}
		// remove timer
		if (!found) {
			clearInterval(wt);
			wt = null;
			animated();
		}
	}
	if (!musicOff) playMusic(2);
	playSound('animateLevel', 300);
	function animated() {
		turns = 0;
		grad45 = false;
		gameRotation = 0;
		repeatClock();
		bl.visible = br.visible = true;
		canTouch = true;
		lastPartTime = levelTime;
		if (GAME && GAME.but_tmp) {
			GAME.but_tmp.visible = true;
			
			if (autoplaying) {autoCollect = true; setTimeout(nextAutoCollect, 500);}
		}
	}
}
function invisibleUnenabled() {
	for (var i=0; i<levelKivid.length; i++) {
		levelKivid[i].hintboosterArea.visible = checkOpen(levelKivid[i]) ? false : true;
	}	
}