function createElements() {
	log('create elements');
	elements = new PIXI.Container();
	
	removeAllChilds(soundContainer);
	
	// music controls
	var musicControlsBG = getAsset('music_controls_bg', stageW*0.11);
	musicControlsBG.position.x = stageW*0.87;
	musicControlsBG.position.y = stageH*0.01;
	var musicControlsBG_shadow = makeShadow(musicControlsBG);
	soundContainer.addChild(musicControlsBG_shadow);
	soundContainer.addChild(musicControlsBG);
	
	var bw;
	var butW = musicControlsBG.width/3.8;
	var pause_mc = getAsset('pause', butW);
	var pause_mc_inactive = getAsset('pause_inactive', butW);
	var sound_mc = getAsset(sndOff ? 'sound_inactive' : 'sound', butW);
	var music_mc = getAsset(musicOff ? 'music_inactive' : 'music', butW);
	
	pause_mc.interactive = sound_mc.interactive = music_mc.interactive = 
	pause_mc.buttonMode = sound_mc.buttonMode = music_mc.buttonMode = true;
		
	pause_mc.anchor.x = sound_mc.anchor.x = music_mc.anchor.x = 0.5;
	pause_mc.anchor.y = sound_mc.anchor.y = music_mc.anchor.y = 0.5;
	pause_mc.position.y = sound_mc.position.y = music_mc.position.y = musicControlsBG.position.y + musicControlsBG.height/2;
	pause_mc.position.x = musicControlsBG.position.x + musicControlsBG.width*0.25;
	music_mc.position.x = musicControlsBG.position.x + musicControlsBG.width*0.5;
	sound_mc.position.x = musicControlsBG.position.x + musicControlsBG.width*0.75;

	
	soundContainer.addChild(pause_mc);
	soundContainer.addChild(sound_mc);
	soundContainer.addChild(music_mc);
	elements.pause_mc = pause_mc;
	elements.sound_mc = sound_mc;
	elements.music_mc = music_mc;
	
	makeHint(pause_mc, xmlValue('hintPause'), 'LB', stageW*0.12, pause_mc.width/2,pause_mc.height/3);
	makeHint(music_mc, xmlValue('hintMusic'), 'LB', stageW*0.12, music_mc.width/2,music_mc.height/3);
	makeHint(sound_mc, xmlValue('hintSound'), 'LB', stageW*0.12, sound_mc.width/2,sound_mc.height/3);
	
	sound_mc.on('click', toggleSound).on('touchend', toggleSound);
	music_mc.on('click', toggleMusic).on('touchend', toggleMusic);
	if (tutorialStep==1) {
		pause_mc.texture = assets.resources['pause_inactive'].texture;
	} else {
		pause_mc.on('click', makePause).on('touchend', makePause);
	}
	
	function makePause() {
		// pause
		if (tutorialStep!=0) return;
		pause_mc.texture = assets.resources['pause_inactive'].texture;
		if (!havePopups) drawPause();
	}
	function toggleSound() {
		// sound on/off
		sndOff = !sndOff;
		sound_mc.texture = assets.resources[sndOff ? 'sound_inactive' : 'sound'].texture;
		analytics('/api/settings?set=sound&val='+(sndOff ? 0 : 1));
	}
	function toggleMusic() {
		// music on/off
		musicOff = !musicOff;
		music_mc.texture = assets.resources[musicOff ? 'music_inactive' : 'music'].texture;
		analytics('/api/settings?set=music&val='+(musicOff ? 0 : 1));
		if (musicOff) {
			stopMusic();
		} else {
			playMusic(2);
		}
	}

	elements.help2But = initBUT(xmlValue('levelHelpButton'),'green');
	elements.help2But.scale.set(0.6);
	elements.help2But.position.x = musicControlsBG.position.x + musicControlsBG.width*0.95 - elements.help2But.w*0.57;
	elements.help2But.position.y = musicControlsBG.position.y + musicControlsBG.height;
	elements.addChild(elements.help2But);
	elements.help2But.visible = false;
	elements.openAbiHelp = function () {
		elements.help2But.visible = false;
		openHelp('level_help_button');
		clockStop();
	};
	elements.help2But.on('click', elements.openAbiHelp).on('touchend', elements.openAbiHelp);
	
	
	// coins
	var money_bg = getAsset('elements_coin', 'auto', stageH*0.076);
	money_bg.anchor.y = 0.5;
	money_bg.position.x = stageW*0.012;
	money_bg.position.y = stageH*0.05;
	var moneyBG_shadow = makeShadow(money_bg);
	elements.addChild(moneyBG_shadow);
	elements.addChild(money_bg);
	
	elements.t_money = createText(money, {fontSize:18, width:money_bg.height*2.1, x:money_bg.position.x + money_bg.height*1.85, y:money_bg.position.y});
	elements.t_money.anchor.y = elements.t_money.anchor.x = 0.5;
	elements.addChild(elements.t_money);
	
	// score
	elements.t_levscore = createText(0, {fontSize:21, x:stageW*0.268, y:stageH*0.05, width:stageW*0.1, align:'right'});
	elements.t_levscore.anchor.x = 1;
	elements.addChild(elements.t_levscore);
	
	if (elements.t_dr) elements.removeChild(elements.t_dr);
	if (elements.dragon) elements.removeChild(elements.dragon);
	elements.t_dr = null;
	elements.dragon = null;
	
	if (isTournament) {
		elements.dragon = getAsset(tournament_type ? 'babyDragon' : 'goldDragon2', 'auto', stageH*0.08);
		elements.dragon.anchor.x = elements.dragon.anchor.y = 0.5;
		elements.dragon.position.x = stageW*0.4;
		elements.dragon.position.y = elements.t_levscore.position.y;
		elements.addChild(elements.dragon);
		elements.t_dr = createText(0+' / '+dragonCount+'   <yellow>0 / 0</yellow>', {fontSize:22, x:elements.dragon.position.x + elements.dragon.width*0.8, align:"left", y:elements.dragon.position.y, width:stageW*0.44});
		elements.t_dr.anchor.x = 0;
		elements.addChild(elements.t_dr);
	}
	
	
	// boosters
	var boosters = new PIXI.Container();
	elements.boosters = boosters;
	boosters.position.x = 0;
	boosters.position.y = -stageH*0.09;
	elements.addChild(boosters);
	
	elements.boosters.init = function(timeQuantity, highlightQuantity) {
		removeAllChilds(boosters);
		bw = stageW*0.07;
		boosters.shuffleBut = bootserButton('shuffle', prices.shuffle, 0);
		boosters.shuffleBut.anchor.x = 0.5;
		boosters.shuffleBut.position.x = stageW*0.62;
		boosters.addChild(boosters.shuffleBut);
		boosters.shuffleBut.refreshQuantity(999);
		boosters.shuffleBut.on('click', elements.pressElementsShuffleBut).on('touchend', elements.pressElementsShuffleBut);
		
		boosters.timeBooster = bootserButton('boosters_time', prices.timeboost, 3);
		boosters.timeBooster.anchor.x = 0.5;
		boosters.timeBooster.position.x = stageW*0.71;
		boosters.addChild(boosters.timeBooster);
		boosters.timeBooster.refreshQuantity(timeQuantity);
		boosters.timeBooster.on('click', elements.pressFriendTimeBooster).on('touchend', elements.pressFriendTimeBooster);
		
		boosters.highlightBut = bootserButton('boosters_highlight', prices.highlight);
		boosters.highlightBut.anchor.x = 0.5;
		boosters.highlightBut.position.x = stageW*0.8;
		boosters.addChild(boosters.highlightBut);
		boosters.highlightBut.refreshQuantity(highlightQuantity);
		boosters.highlightBut.on('click', elements.pressHighlightBut).on('touchend', elements.pressHighlightBut);
		
		
		function bootserButton(icotype, price, max_used_times) {
			max_used_times = typeof max_used_times !== 'undefined' ? max_used_times : 0;

			var but = new PIXI.Sprite();
			but.anchor.x = but.anchor.y = 0.5;
			but.total = -1;
			but.max_used_times = max_used_times;
			but.icotype = icotype;
			but.price = price;
			
			but.refreshQuantity = function(n) {
				if (this.total<0) this.total = n;
				if (n<0) n=0;
				this.enable();
			};
			but.disable = function() {
				removeAllChilds(this);
				if (hinta) hideHint(true);
				var round = getAsset('booster_but', bw*1.35);
				round.anchor.x = round.anchor.y = 0.5;
				but.addChild(round);
				var ico = getAsset(this.icotype, bw);
				ico.alpha = 0.25;
				ico.anchor.x = ico.anchor.y = 0.5;
				this.addChild(ico);
				but.disabled = true;
				this.buttonMode = this.interactive = false;
			};
			but.enable = function() {
				removeAllChilds(this);
				var round = getAsset('booster_but', bw*1.4);
				round.anchor.x = round.anchor.y = 0.5;
				but.addChild(round);
				var ico = getAsset(this.icotype, bw);
				ico.anchor.x = ico.anchor.y = 0.5;
				this.addChild(ico);
				
				var badgeType = this.icotype=='shuffle' ? 'infinity_badge' : 'wheel_badge';
				var forCoins = this.total<=0;
				var coin = forCoins ? getAsset('booster_coin_bg', bw*1.17) : getAsset(badgeType, bw*0.47);
				coin.anchor.x = coin.anchor.y = 0.5;
				coin.position = {x:-Math.round(bw*(forCoins ? 0.04 : 0.32)), y:Math.round(bw*0.5)};
				this.addChild(coin);
				var txt = forCoins ? this.price : this.total;
				if (this.total!=999) {
					var t = createText(txt, {fontSize:14, x:forCoins ? bw*0.23 : coin.position.x, y:coin.position.y-1, width:coin.width, stroke:3});
					this.addChild(t);
				}
	
				but.disabled = false;
				this.buttonMode = this.interactive = true;
			};
			but.useBooster = function() {
				this.total--;
				this.refreshQuantity(this.total);
				if (this.max_used_times>0) {
					this.max_used_times--;
					if (this.max_used_times==0) this.disable();
				}
			};
			
			but.enable();
			but.visible = false;
			return but;
		}
	};
	elements.showBoosters = function (boosterHints) {
		// show boosters one by one
		var boosters = [elements.boosters.shuffleBut,elements.boosters.timeBooster,elements.boosters.highlightBut];
		var controls = [elements.boosters.shuffleAvailable,elements.boosters.timeAvailable,elements.boosters.highlightAvailable];
		nextBooster();
		function nextBooster() {
			if (boosters.length>0) {
				var boost = boosters.shift();
				var control = controls.shift();
				boost.visible = control;
				
				var bw = stageW*0.04;
				if (boost == elements.boosters.timeBooster) makeHint(boost, boosterHints.timeboost, 'BL', stageW*0.21, 0,bw);
				if (boost == elements.boosters.shuffleBut) makeHint(boost, boosterHints.shuffle, 'BL', stageW*0.21, 0,bw);
				if (boost == elements.boosters.highlightBut) makeHint(boost, boosterHints.highlight, 'BL', stageW*0.21, 0,bw);
				if (control) animateBooster(boost); else nextBooster();
			}
		}
		function animateBooster(boost) {
			var w = boost.width;
			boost.alpha = 0.1; boost.width = 0.2*w; boost.height = 0.2*w;
			TweenLite.to(boost, 0.25, {alpha:1, width:w, height:w});
			setTimeout(nextBooster, 200);
		}
	};
	
	// clock
	if (tutorialStep!=1) {
		var time_bg = isTournament ? getAsset('timerBG_alone', 'auto', stageH*0.089) : getAsset('timerBG', stageW*0.28);
		elements.timerBG = time_bg;
		time_bg.anchor.y = 0.5;
		
		time_bg.position.x = stageW*0.275;
		time_bg.position.y = isTournament ? stageH*0.056 : stageH*0.047;
		var time_bg_Shadow = makeShadow(time_bg);
		elements.addChild(time_bg_Shadow);
		
		if (!isTournament) {
			progressSliderStartWidth = time_bg.width*0.745;
			
			var timer_slider_bg = getAsset('loading1', progressSliderStartWidth);
			timer_slider_bg.position.x = time_bg.position.x + time_bg.width*0.23;
			timer_slider_bg.position.y = time_bg.position.y - time_bg.height*0.2;
			elements.progressSlider = getAsset('timeSlider', progressSliderStartWidth);
			
			elements.progressSlider.height = timer_slider_bg.height = time_bg.height*0.48;
			elements.progressSlider.position = timer_slider_bg.position;
			var time_bg_Shadow2 = makeShadow(timer_slider_bg);
			elements.addChild(time_bg_Shadow2);
			elements.addChild(timer_slider_bg);
			elements.addChild(elements.progressSlider);
			setSlider(0);
		}
		
		elements.addChild(time_bg);
		var sectorMask = new PIXI.Sprite();
		elements.sector = sectorMask;
		sectorMask.anchor.x = sectorMask.anchor.y = 0.5;
		sectorMask.position = {x:time_bg.position.x + time_bg.height*0.474, y:time_bg.position.y + time_bg.height*(isTournament ? 0 : 0.018)};
		elements.addChild(sectorMask);
				
		var clockArea = new PIXI.Graphics();
		clockArea.beginFill(0xff0000,0);
		clockArea.position.x = time_bg.position.x;
		clockArea.position.y = time_bg.position.y - time_bg.height/2;
		clockArea.drawRect(0, 0, time_bg.height, time_bg.height);
		clockArea.endFill();
		elements.addChild(clockArea);
		makeHint(clockArea, xmlValue('hintTimer'), 'RB', stageW*0.15, -clockArea.width/3,0);
	}
	//stars
	elements.greyStars = function() {
		if (elements.star1) {removeAllChilds(elements.star1); removeAllChilds(elements.star2); removeAllChilds(elements.star3);}
		elements.star1 = new PIXI.Container(); var star1 = getAsset('starGrey', stageW*0.04); star1.anchor.x = star1.anchor.y = 0.5;
		elements.star2 = new PIXI.Container(); var star2 = getAsset('starGrey', stageW*0.04); star2.anchor.x = star2.anchor.y = 0.5;
		elements.star3 = new PIXI.Container(); var star3 = getAsset('starGrey', stageW*0.04); star3.anchor.x = star3.anchor.y = 0.5;
		elements.star1.position.y = elements.star3.position.y = elements.star2.position.y = time_bg.position.y + time_bg.height*0.4;
		elements.addChild(elements.star1); elements.star1.addChild(star1);
		elements.addChild(elements.star2); elements.star2.addChild(star2);
		elements.addChild(elements.star3); elements.star3.addChild(star3);
		
		elements.star1.interactive = elements.star2.interactive = elements.star3.interactive = true;
		elements.star1.nr = 1;
		elements.star2.nr = 2;
		elements.star3.nr = 3;
		elements.star1.on('touchstart', initStarHints).on('touchend', hideHint).on('touchendoutside',hideHint).on('mouseover', initStarHints).on('mouseout', hideHint);
		elements.star2.on('touchstart', initStarHints).on('touchend', hideHint).on('touchendoutside',hideHint).on('mouseover', initStarHints).on('mouseout', hideHint);
		elements.star3.on('touchstart', initStarHints).on('touchend', hideHint).on('touchendoutside',hideHint).on('mouseover', initStarHints).on('mouseout', hideHint);
	};
	if (!isChallenge && tutorialStep!=1) elements.greyStars();
	
	elements.updateClock = function() {
		if (elements.t_time) elements.removeChild(elements.t_time);
		if (levelTime<levelTimeStart && !isChallenge) {
			removeAllChilds(sectorMask);
			// draw time sector
			var sector = new PIXI.Graphics(); //!!!actually sector is mask for clock asset
			sector.beginFill(0xffe670);
			sector.arc(0, 0, time_bg.height*(isTournament ? 0.36 : 0.385), -Math.PI/2, Math.PI*1.5 - Math.PI*2*((levelTime+0.001)/levelTimeStart)); // cx, cy, radius, startAngle, endAngle
			sector.lineTo(0,0);
			sector.endFill();
			sectorMask.addChild(sector);

		}
		elements.t_time = createText(convertToTime(levelTime), {fontSize:14, x:sectorMask.position.x + sectorMask.width*0.23, y:sectorMask.position.y, width:sectorMask.width*0.9, color:"#ffffff"});
		elements.t_time.anchor.x = elements.t_time.anchor.y = 0.5;
		elements.addChild(elements.t_time);

	};
	if (GAME && tutorialStep!=1) elements.updateClock();
	
	gameContainer.addChild(elements);
	
	
	
	
	// booster functions
	var notouch; // or loader?
	elements.addNotouch = function() {
		if (!notouch) {
			notouch = wholeBox(0xff0000, dev ? 0.22 : 0);
			notouch.interactive = true;
			stage.addChild(notouch);
		}
	};
	elements.removeNotouch = function() {
		if (notouch) stage.removeChild(notouch);
		notouch = null;
	};
	
	elements.pressFriendTimeBooster = function () {
		autoCollect = false;
		// add friend sent time
		if (!elements.boosters.timeBooster.disabled) {
			elements.boosters.timeBooster.disable();
			if (hinta) hideHint();
			clockStop();
			elements.addNotouch();
			if (friendBonusTimes > 0) buy('20sekBonus');
			else checkMoney(prices.timeboost, '20sekBonus');
		}
	};
	elements.makeTimeBooster = function() {
		//animation time booster
		var ico20Sec = getAsset('boosters_time', bw);
		ico20Sec.position.x = boosters.timeBooster.position.x + boosters.position.x;
		ico20Sec.position.y = boosters.timeBooster.position.y + boosters.position.y;
		ico20Sec.anchor = boosters.timeBooster.anchor;
		stage.addChild(ico20Sec);
		TweenLite.to(ico20Sec, 0.44, {x:stageW*0.3, y:stageH*0.049, onComplete:function() {
			addVremja(20);
			lastPartTime = levelTime*1;
			
			var sheet = getSheet('tileExplose');
			makeSheet(sheet, stageW*0.16, false, 0.5, ico20Sec.position.x, ico20Sec.position.y, 0, true);
			stage.addChild(sheet);
			stage.removeChild(ico20Sec);
			playSound('friendTimeBonus');
			ico20Sec = null;
			elements.removeNotouch();
			
			if (elements.boosters.timeBooster.max_used_times>0) elements.boosters.timeBooster.enable();
			if (autoplaying) autoCollect = true;
			if (autoCollect) nextAutoCollect();
		}});
			
		friendBonusTimes--;
		elements.boosters.timeBooster.useBooster();
		elements.boosters.timeBooster.disable();
	};
	elements.pressElementsShuffleBut = function () {
		if (!elements.boosters.shuffleBut.disabled) shuffle();
	};
	elements.pressHighlightBut = function () {
		if (!highLightMode && !elements.boosters.shuffleBut.disabled) {
			elements.boosters.highlightBut.disable();
			if (hinta) hideHint();
			if (highlightQuantity>0) buy('highlight');
			else checkMoney(prices.highlight, 'highlight');
		}
	};
	elements.makeHighlight = function() {
		highLightMode = true;
		lastPartTime = levelTime*1;
		invisibleUnenabled();
		elements.boosters.highlightBut.useBooster();
		elements.boosters.highlightBut.disable();
	};
	elements.makeHintBooster = function() {
		hintBoostMode = true;
		lastPartTime = levelTime*1;
		elements.boosters.hintBoostBut.useBooster();
		elements.boosters.hintBoostBut.disable();
	};
	
	
	
	
	
	// challenge ---------------------------------------------------------------------------------------------
	elements.placeChallengeCoins = function() {
		
		setSlider(progressSliderStartWidth);
		elements.progressSlider.width = progressSliderStartWidth;
				
		elements.wincoin1 = new PIXI.Sprite();
		elements.wincoin1.position.x = elements.progressSlider.position.x;
		elements.wincoin2 = new PIXI.Sprite();
		elements.wincoin2.position.x = elements.progressSlider.position.x + progressSliderStartWidth*((levelTimeStart-star_percent[1])/levelTimeStart);
		elements.wincoin3 = new PIXI.Sprite();
		elements.wincoin3.position.x = elements.progressSlider.position.x + progressSliderStartWidth*((levelTimeStart-star_percent[0])/levelTimeStart);
		elements.wincoin1.anchor.x = elements.wincoin2.anchor.x = elements.wincoin3.anchor.x = 0.5;
		elements.wincoin1.position.y = elements.wincoin2.position.y = elements.wincoin3.position.y = elements.progressSlider.position.y + elements.progressSlider.height*0.05;
		elements.addChild(elements.wincoin1);
		elements.addChild(elements.wincoin2);
		elements.addChild(elements.wincoin3);
		
		//2
		var line2 = new PIXI.Graphics();
		line2.beginFill(0x4E3000, 1);
		line2.drawRect(0, 0, 1, elements.progressSlider.height);
		line2.endFill();
		elements.wincoin2.addChild(line2);
		var keys21 = getAsset('key', stageW*0.04);
		var keys22 = getAsset('key', stageW*0.04);
		keys21.anchor.x = keys22.anchor.x = 0.3;
		keys21.position.x = -keys21.width*0.16;
		keys22.position.x = keys21.width*0.16;
		keys21.position.y = keys22.position.y = line2.height*0.5;
		elements.wincoin2.addChild(keys21);
		elements.wincoin2.addChild(keys22);
		
		//3
		var line3 = new PIXI.Graphics();
		line3.beginFill(0x4E3000, 1);
		line3.drawRect(0, 0, 1, elements.progressSlider.height);
		line3.endFill();
		elements.wincoin3.addChild(line3);
		var keys31 = getAsset('key', stageW*0.04);
		var keys32 = getAsset('key', stageW*0.04);
		var keys33 = getAsset('key', stageW*0.04);
		keys31.anchor.x = keys32.anchor.x = keys33.anchor.x = 0.3;
		keys31.position.x = -keys31.width*0.27;
		keys33.position.x = keys31.width*0.27;
		keys31.position.y = keys32.position.y = keys33.position.y = line3.height*0.5;
		elements.wincoin3.addChild(keys31);
		elements.wincoin3.addChild(keys32);
		elements.wincoin3.addChild(keys33);
		
		//1
		var keys1 = getAsset('key', stageW*0.04);
		keys1.anchor.x = 0.3;
		keys1.position.y = line2.height*0.5;
		elements.wincoin1.addChild(keys1);
	};
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
}
function showHint() {
	if (lastPartTime != levelTime) return;
	
	var clp, clp2, i, z;
	hintSucessful = false;
	
	if (havePair()) {
		disableAutoHightlighting();
		
		if (ft1Data && ft2Data) {
			hintSucessful = true;
		}
		if (firstTile && firstTile.visible && checkOpen(firstTile)) {
			for (z=0; z<levelKivid.length; z++) {
				clp2 = levelKivid[z];
				if (clp2.visible && firstTile!=clp2 && firstTile.tile==clp2.tile && checkOpen(clp2)) {
					
					ft1Data = {xx:firstTile.xx, yy:firstTile.yy, zz:firstTile.zz};
					ft2Data = {xx:clp2.xx, yy:clp2.yy, zz:clp2.zz};
					
					hintSucessful = true;
					break;
				}
			}
			
		}
		if (!hintSucessful) {
			for (i = 0; i<levelKivid.length; i++) {
				clp = levelKivid[i];
				if (clp.visible && checkOpen(clp)) {
					for (z=0; z<levelKivid.length; z++) {
						clp2 = levelKivid[z];
						if (clp2.visible && clp!=clp2 && clp.tile==clp2.tile && checkOpen(clp2)) {
							
							ft1Data = {xx:clp.xx, yy:clp.yy, zz:clp.zz};
							ft2Data = {xx:clp2.xx, yy:clp2.yy, zz:clp2.zz};
							
							hintSucessful = true;
							break;
						}
					}
				}
				if (hintSucessful) break;
			}
		}
		if (hintSucessful) {
			playSound('kivi_vihje');
			showSelectedPlusAutohint();
			blinkArrows();
		}
	}
}
function animateStar(clp) {
	if (isTournament || isChallenge) return;
	// animate star
	removeAllChilds(clp);
	var w = stageW*0.05;
	var star = getAsset('starGold', w); star.anchor.x = star.anchor.y = 0.5;
	star.width = star.height = w*0.3;
	clp.addChild(star);
	TweenLite.to(star, 0.35, {width:w*1.4, height:w*1.4, onComplete:function() {
		TweenLite.to(star, 0.35, {width:w, height:w});
	}});
	// add stars sheet to star
}
function setSlider(w) {
	if (elements.progressSlider) elements.progressSlider.width = w;
}
