function openOffer() {
	// open ordinary offer (from icon)
	showOfferFirsttime = false; // disable autoshowing if clicked manually before playing or showed once.
	if (offerData.code == 'firstRoadblockOffer') {openFirsttimeOffer(); return;}
	
	offerPopup = new PIXI.Container();
	
	//log('offerdata = ');
	//log(offerData);
	
	var ttype = jsonObject.tournament.ttype;
	
	var bg = new PIXI.Sprite.fromImage(offerData.code == 'tournamentOffer' ? (ttype ? 'popup_pink_large' : 'popup_blue_large') : offerData.background);
	if (bg.texture.baseTexture.hasLoaded==true) showOffer();
	else bg.texture.baseTexture.on('loaded', showOffer).on('error', function() {
		bg = getAsset(offerData.code == 'tournamentOffer' ? (ttype ? 'popup_pink_large' : 'popup_blue_large') : 'popup_large', 'auto', stageH); showOffer();
	});
	function showOffer() {
		removeLoader();
		if (offerData.code != 'tournamentOffer') {
			bg.height = stageH;
			bg.scale.x = bg.scale.y;
		} else {
			bg.width = stageH*0.84*(1140/990);
			bg.height = stageH*0.84;
			bg.position.y = stageH/2 - bg.height/2;
		}
		offerPopup.addChild(bg);
		offerPopup.bg = bg;
		var centerX = parseInt(bg.width/2);
		
		var closeBut = getAsset('closeBut', bg.width/17);
		if (offerData.code != 'tournamentOffer') {
			closeBut.position.x = bg.width/1.18;
			closeBut.position.y = bg.height/8.15;
		} else {
			closeBut.position.x = bg.width*0.953;
			closeBut.position.y = bg.height/7;
		}
		closeBut.interactive = closeBut.buttonMode = true;
		offerPopup.addChild(closeBut);
		
		var si;
		var offer_tim = offerData.timeLeft;
		btnAction = offerData.btnAction;
		
		
		closeBut.on('click', removeOffer).on('touchend', removeOffer);
		function removeOffer() {
			clearInterval(si);
			quitPopup(offerPopup);
			refreshTopData();
			tryToBuy = ''; //?????
			if (makeNextLevel && animeclp==null) setTimeout(startNextLev, 360);
		}
		
		var but = initBUT(offerData.btnText, 'green');
		centerBut(but, centerX);
		but.position.y = bg.height*0.66;
		setTimeout(function() {
			but.on('click', resetButAndBuy).on('touchend', resetButAndBuy);
		}, 300); // wait till animate
		function resetButAndBuy() {
			but.disable();
			buyOffer();
		}
		
		showTexts();
		
		// multiple bundles...
		if (offerData.maxQuantity>1) {
			var bundle = new PIXI.Container();
			bundle.position.x = bg.width*0.14;
			bundle.position.y = bg.height*0.8;
			offerPopup.addChild(bundle);
			
			initBundle(1);
			
			but.position.x = bg.width*0.85 - but.w;
			but.position.y = bundle.position.y - but.h/2;
			
		}
		offerPopup.addChild(but);
			
		function showTexts() {
			if (offerData.code!='tournamentOffer') {
				
				var t1 = createText(xmlValue('personalOffer'), {fontSize:15, bold:false, x:bg.width*0.633, y:bg.height*0.375, width:bg.width*0.19, autoResize:true});
				offerPopup.addChild(t1);
				
				var coin = getAsset('coin', bg.width*0.06);
				coin.anchor.y = 0.5;
				coin.position.x = bg.width*0.55;
				coin.position.y = bg.height*0.44;
				offerPopup.addChild(coin);
				
				var t2 = createText(offerData.amount, {fontSize:30, x:coin.position.x + coin.width*1.6, y:coin.position.y, width:bg.width*0.1});
				offerPopup.addChild(t2);
				var t3 = createText(xmlValue('forTxt'), {fontSize:23, x:t1.position.x, y:bg.height*0.5, width:bg.width*0.25});
				offerPopup.addChild(t3);
				var t4 = createText(coinFormat(offerData.price)+' '+offerData.currency.toLowerCase(), {fontSize:33, color:'#FFB93B', x:t1.position.x, y:bg.height*0.565, width:bg.width*0.25});
				offerPopup.addChild(t4);
				var t5 = createText(xmlValue('regularPrice').replace('[price]', offerData.fullPrice+' '+offerData.currency.toLowerCase()), {fontSize:15, stroke:0, shadow:false, color:'#ff0000', x:t1.position.x, y:bg.height*0.615, width:bg.width*0.25});
				offerPopup.addChild(t5);
				
				var badge = getAsset('blue_badge1', bg.width*0.2);
				badge.anchor.x = badge.anchor.y = 0.5;
				badge.position.x = bg.width*0.78;
				badge.position.y = bg.height*0.4;
				var b1 = createText(xmlValue('save'), {fontSize:21, x:badge.position.x, y:badge.position.y - badge.height*0.1, width:badge.width*0.88});
				var b2 = createText(offerData.percent+'%', {fontSize:21, x:badge.position.x, y:badge.position.y + badge.height*0.1, width:badge.width*0.88});
				//badge.rotation = b1.rotation = b2.rotation = 15 * Math.PI/180;
				badge.addChild(b2);
				offerPopup.addChild(badge);
				offerPopup.addChild(b1);
				offerPopup.addChild(b2);
				
				var timerLabel = createText(xmlValue('offerTimer'), {fontSize:22, x:0, y:bg.height*0.695, width:bg.width*0.6});
				offerPopup.addChild(timerLabel);
				var timertext = createText(convertToTime(offer_tim, true), {fontSize:22, color:'#FFCC00', x:0, y:timerLabel.position.y, width:bg.width*0.3});
				timerLabel.anchor.x = timertext.anchor.x = 0;
				offerPopup.addChild(timerLabel);
				offerPopup.addChild(timertext);
				
				var wt = timerLabel.width + 12 + timertext.width;
				timerLabel.position.x = centerX - wt/2;
				timertext.position.x = timerLabel.position.x + timerLabel.width + 12;

				si = setInterval(function () {
					offer_tim--;
					if (offer_tim<0) {
						offerPurchase = true;
						removeOffer();
						offer_tim = 0;
					}
					updateTxt(timertext, convertToTime(offer_tim, true));
				}, 1000);
				
				
				
			} else {
				
				// tournament offer texts
				
				/*var coin = getAsset('coin', bg.width*0.07);
				coin.anchor.y = 0.5;
				coin.position.x = bg.width*0.53;
				coin.position.y = bg.height*0.44;
				offerPopup.addChild(coin);
				
				var tok = getAsset('token', bg.width*0.07);
				tok.anchor.y = 0.5;
				tok.position.x = bg.width*0.65;
				tok.position.y = coin.position.y;
				offerPopup.addChild(tok);*/
				
				var chest = getAsset('ChestWithGemsCoins', bg.width*0.38);
				chest.anchor.x = 0.5;
				chest.position.x = bg.width/2;
				chest.position.y = bg.height*0.23;
				offerPopup.addChild(chest);
				
				var t2 = createText(xmlValue('tournamentOffer'), {fontSize:21, color:'white', x:bg.width/2, y:bg.height/7.2, width:bg.width*0.7});
				offerPopup.addChild(t2);
				
				//var centerBox = coin.position.x + coin.width*1.66;
				
				var t3 = createText('Grab the special tournament deal!', {fontSize:24, color:"yellow", bold:false, stroke:4, x:centerX, y:bg.height*0.71, width:bg.width*0.8, multiline:false});
				offerPopup.addChild(t3);
				
				var t4 = createText('This special offer is only valid during a tournament', {color:'white', stroke:4, fontSize:18, bold:false, x:centerX, y:bg.height*0.79, width:bg.width*0.8, multiline:true});
				offerPopup.addChild(t4);
				
				var coin_ico = getAsset('sales100', bg.width*0.13);
				coin_ico.position.y = bg.height*0.83;
				coin_ico.position.x = bg.width/2 - 28 - coin_ico.width;
				offerPopup.addChild(coin_ico);
				
				var coin_sum = createText(offerData.amount, {fontSize:18, bold:false, color: 'yellow', x:coin_ico.position.x+coin_ico.width*0.5, y:coin_ico.position.y + coin_ico.height - 6});
				coin_sum.anchor.x = 0.5;
				offerPopup.addChild(coin_sum);
				
				var plus_ico = getAsset('btn_plus', coin_ico.width*0.4);
				plus_ico.position.x = bg.width/2;
				plus_ico.position.y = coin_ico.position.y + coin_ico.height/2;
				plus_ico.anchor.y = plus_ico.anchor.x = 0.5;
				offerPopup.addChild(plus_ico);
				
				var token_ico = getAsset('tokenPileSmall', coin_ico.width);
				token_ico.position.x = plus_ico.position.x + 30;
				token_ico.position.y = coin_ico.position.y;
				offerPopup.addChild(token_ico);
				
				if (!offerData.tokenAmount) offerData.tokenAmount='20';
				var token_sum = createText(offerData.tokenAmount, {fontSize:18, bold:false, color: 'yellow', x:token_ico.position.x+token_ico.width*0.5, y:token_ico.position.y + token_ico.height - 6});
				token_sum.anchor.x = 0.5;
				offerPopup.addChild(token_sum);
				
				/*var t4 = createText(offerData.amount, {fontSize:35, x:coin.position.x + coin.width*0.75, y:coin.position.y, width:bg.width*0.25});
				offerPopup.addChild(t4);
				t4.anchor.x = 0;*/
				
				/*var t41 = createText(offerData.tokenAmount, {fontSize:35, x:tok.position.x + tok.width*0.75, y:tok.position.y, width:bg.width*0.25});
				t41.anchor.x = 0;
				offerPopup.addChild(t41);*/
				
				/*var t6 = createText(xmlValue('forTxt'), {fontSize:23, x:centerBox, y:bg.height*0.5, width:bg.width*0.25});
				offerPopup.addChild(t6);
				
				var t5 = createText(offerData.price+' '+offerData.currency.toLowerCase(), {fontSize:40, x:centerBox, y:bg.height*0.57, width:bg.width*0.25});
				offerPopup.addChild(t5);*/
				
				
				but.position.y = bg.height*1.03;
			}
		}

		
		
	
		
		
		
		
		// bundle
		function initBundle(nr) {
			removeAllChilds(bundle);
			
			var bg2 = getAsset('offerBundle', bg.width*0.73);
			bg2.anchor.y = 0.5;
			bundle.addChild(bg2);
			
			var prevBut = getAsset('go_next', bg2.width*0.06);
			prevBut.on('click', prevF).on('touchend', prevF);
			bundle.addChild(prevBut);
			var nextBut = getAsset('go_prev', bg2.width*0.06);
			nextBut.on('click', nextF).on('touchend', nextF);
			bundle.addChild(nextBut);
			prevBut.anchor.x = nextBut.anchor.x = 0.5;
			prevBut.anchor.y = nextBut.anchor.y = 0.5;
			prevBut.position.x = nextBut.position.x = bg2.width*0.1;
			prevBut.position.y = -bg2.height*0.45;
			nextBut.position.y = bg2.height*0.45;
			prevBut.buttonMode = nextBut.buttonMode = prevBut.interactive = nextBut.interactive = true;

			prevBut.visible = nr>1 && offerData.maxQuantity>1;
			nextBut.visible = nr<offerData.maxQuantity && offerData.maxQuantity>1;

			
			var t_nr = createText(nr, {fontSize:37, x:nextBut.position.x, y:0, width:bg2.width*0.1});
			bundle.addChild(t_nr);
			var bundle_label = createText(nr==1 ? xmlValue('bundleLabel1') : xmlValue('bundleLabelMore'), {align:"left", multiline:true, fontSize:16, color:'yellow', x:bg2.width*0.22, y:0, width:bg2.width*0.1});
			bundle.addChild(bundle_label);
			
			var coin = getAsset('coin', bg2.width*0.07);
			coin.anchor.y = 0.5;
			coin.position.x = bg2.width*0.32;
			bundle.addChild(coin);
			
			var l1 = createText(xmlValue('bundleCoinsLabel'), {fontSize:14, color:'yellow', x:coin.position.x + coin.width*1.2, y:-bg2.height*0.21, width:bg2.width*0.25, autoResize:true});
			l1.anchor.x = 0;
			bundle.addChild(l1);
			var t1 = createText(offerData.amount*nr, {fontSize:18, x:l1.position.x, y:bg2.height*0.17, width:bg2.width*0.1, autoResize:true});
			t1.anchor.x = 0;
			bundle.addChild(t1);
			
			var l2 = createText(xmlValue('bundlePriceLabel'), {fontSize:14, color:'yellow', x:bg2.width*0.62, y:l1.position.y, width:bg2.width*0.24, autoResize:true});
			bundle.addChild(l2);
			var t2 = createText(coinFormat(offerData.price*nr)+' '+offerData.currency.toLowerCase(), {fontSize:19, color:'yellow', x:l2.position.x, y:t1.position.y, width:bg2.width*0.24, autoResize:true});
			bundle.addChild(t2);
		
			btnAction = offerData.btnAction.replace('[quantity]', nr);
			
			function prevF() {
				initBundle(nr-1);
			}
			function nextF() {
				initBundle(nr+1);
			}
		}
		function coinFormat(n) {
			n = Math.round(n*100)/100;
			var s = n.toString();
			var tmp = s.split('.');
			if (tmp.length==1) return s+'.00';
			if (tmp[1].length==1) return s+'0';
			return s;
		}
		
		
		
		
		
		animatePopup(offerPopup);
	}
	
}


//---------------------------------------------------------------------------------------------------------------


function openFirsttimeOffer() {
	// open firsttime offer
	if (firsttimeOfferPopup) return;

	numlog('FRO_open');
	
	firsttimeOfferPopup = new PIXI.Container();
	firsttimeOfferPopup.position.y = stageH*0.05;
	var bg = getAsset('firstBuyOfferBG', 'auto', stageH*0.9);
	firsttimeOfferPopup.bg = bg;
	firsttimeOfferPopup.addChild(bg);
	var centerX = bg.width/2;
	
	var closeBut = getAsset('closeBut', bg.width/18);
	firsttimeOfferPopup.addChild(closeBut);
	closeBut.position.x = bg.width*0.95;
	closeBut.position.y = bg.height*0.06;
	closeBut.interactive = closeBut.buttonMode = true;
	closeBut.on('click', removeOffer).on('touchend', removeOffer);
	function removeOffer() {
		numlog('FRO_close');

		if (offerLeft==0) {offerData = null; offery();}
		clearInterval(si);
		if (makeNextLevel && animeclp==null) setTimeout(startNextLev, 360);
		quitPopup(firsttimeOfferPopup);
	}
	
	var si;
	var offer_tim = offerData.timeLeft;
	btnAction = offerData.btnAction;
	
	var dragon = getSheet('dragon');
	makeSheet(dragon, stageW*0.28, false, 0.5, bg.width*0.177, bg.height*0.6);
	firsttimeOfferPopup.addChild(dragon);

	var label = createText(xmlValue('personalOfferLabel'), {fontSize:25, x:centerX, y:bg.height*0.05, width:bg.width/3});
	firsttimeOfferPopup.addChild(label);
	var t1 = createText(xmlValue('PersonalOffer1txt'), {fontSize:38, color:'yellow', x:bg.width*0.543, y:bg.height*0.2, width:bg.width*0.81, autoResize:true});
	firsttimeOfferPopup.addChild(t1);
	var t2 = createText(xmlValue('PersonalOffer2txt').replace('[percent]', offerData.percent), {fontSize:35, x:t1.position.x, y:bg.height*0.29, width:bg.width*0.83, autoResize:true});
	firsttimeOfferPopup.addChild(t2);

	
	centerX = bg.width*0.6;
	
	// pack1 data
	var icon_bg1, icon_bg2, icon_bg3;
		
	drawBox('coinPack1', bg.width*0.37, 0);
	drawBox('coinPack2', centerX, 1);
	drawBox('coinPack3', bg.width*0.83, 2);
	
	function drawBox(icoType, posX, nr) {
		var iconbg = getAsset('stopClpBG', bg.width*0.215);
		iconbg.anchor.x = 0.5;
		iconbg.position.x = posX;
		iconbg.position.y = bg.height*0.43;
		firsttimeOfferPopup.addChild(iconbg);
		var icoW = [0.52, 0.61, 0.83];
		var icon = getAsset(icoType, iconbg.width*icoW[nr]);
		icon.anchor.x = 0.5;
		icon.position.x = posX;
		var icoY = [0.09, 0.02, -0.1];
		icon.position.y = iconbg.height*icoY[nr] + iconbg.position.y;
		var glow = getAsset('glow', bg.width*0.57);
		glow.anchor.x = glow.anchor.y = 0.5;
		glow.position.x = icon.position.x;
		glow.position.y = bg.height*0.55;
		firsttimeOfferPopup.addChild(glow);
		firsttimeOfferPopup.addChild(icon);
		var coin = getAsset('coin', iconbg.width*0.3);
		coin.anchor.x = coin.anchor.y = 0.5;
		coin.position.x = posX - iconbg.width*0.23;
		coin.position.y = iconbg.position.y + iconbg.height*0.8;
		firsttimeOfferPopup.addChild(coin);
		var p = createText(offerData.prices[nr].amount, {fontSize:29, x:coin.position.x+coin.width*0.5, y:coin.position.y, width:iconbg.width*0.5});
		p.anchor.x = 0;
		firsttimeOfferPopup.addChild(p);
		coina = getAsset('coin', iconbg.width*0.14);
		coina.anchor.x = coina.anchor.y = 0.5;
		coina.position.x = posX + iconbg.width*0.12 - (nr==2 ? coina.width : 0);
		coina.position.y = iconbg.position.y + iconbg.height*0.6;
		firsttimeOfferPopup.addChild(coina);
		var pa = createText(offerData.prices[nr].amountBefore, {fontSize:19, x:coina.position.x+coina.width*0.7, y:coina.position.y, width:iconbg.width*0.3});
		pa.anchor.x = 0;
		firsttimeOfferPopup.addChild(pa);
		var lin = new PIXI.Graphics();
		lin.lineStyle(3, 0xcc0000, 1);
		lin.moveTo(coina.position.x - coina.width/1.7, coina.position.y + coina.height/1.9);
		lin.lineTo(pa.position.x + pa.width, pa.position.y - pa.height/3);
		firsttimeOfferPopup.addChild(lin);
		
		if (nr==0) icon_bg1 = iconbg;
		else if (nr==1) icon_bg2 = iconbg;
		else if (nr==2) icon_bg3 = iconbg;
	}


	var badge = getAsset('blue_badge1', bg.width*0.265);
	badge.anchor.x = badge.anchor.y = 0.5;
	badge.position.x = bg.width*0.07;
	badge.position.y = bg.height*0.117;
	badge.rotation = -10 * Math.PI/180;
	var b1 = createText(xmlValue('personalOfferBadge1'), {fontSize:60, stroke:14, x:0, y:-80, width:200});
	badge.addChild(b1);
	var b2 = createText(xmlValue('personalOfferBadge2'), {fontSize:60, color:"yellow", stroke:14, x:0, y:0, width:200});
	badge.addChild(b2);
	var b3 = createText(xmlValue('personalOfferBadge3'), {fontSize:60, stroke:14, x:0, y:80, width:200});
	badge.addChild(b3);
	firsttimeOfferPopup.addChild(badge);

	
	
	
	var tb1 = createText(xmlValue('personalOfferBox1').replace('[percent]', offerData.percent), {fontSize:18, color:'yellow', x:icon_bg1.position.x, y:bg.height*0.4, width:icon_bg1.width*0.94, autoResize:true});
	var tb2 = createText(xmlValue('personalOfferBox2').replace('[percent]', offerData.percent), {fontSize:16, x:centerX, y:bg.height*0.39, width:icon_bg2.width});
	var ribbon = getAsset('ribbon2', icon_bg2.width*1.19);
	ribbon.anchor.x = 0.5;
	ribbon.position.x = centerX;
	ribbon.position.y = tb2.position.y - ribbon.height*0.39;
	firsttimeOfferPopup.addChild(ribbon);
	firsttimeOfferPopup.addChild(tb2);
	var tb3 = createText(xmlValue('personalOfferBox3').replace('[percent]', offerData.percent), {fontSize:18, color:'yellow', x:icon_bg3.position.x, y:bg.height*0.4, width:icon_bg3.width*0.94, autoResize:true});
	firsttimeOfferPopup.addChild(tb3);
	firsttimeOfferPopup.addChild(tb1);


	var but1 = initBUT(offerData.prices[0].price+' '+offerData.currency.toLowerCase(), '');
	centerBut(but1, icon_bg1.position.x);
	but1.on('click', buyPersonalOffer1).on('touchend', buyPersonalOffer1);
	firsttimeOfferPopup.addChild(but1);
	
	var but2 = initBUT(offerData.prices[1].price+' '+offerData.currency.toLowerCase(), '');
	centerBut(but2, centerX);
	but2.on('click', buyPersonalOffer2).on('touchend', buyPersonalOffer2);
	firsttimeOfferPopup.addChild(but2);
	
	var but3 = initBUT(offerData.prices[2].price+' '+offerData.currency.toLowerCase(), '');
	centerBut(but3, icon_bg3.position.x);
	but3.on('click', buyPersonalOffer3).on('touchend', buyPersonalOffer3);
	
	but1.position.y = but2.position.y = but3.position.y = bg.height*0.73;
	firsttimeOfferPopup.addChild(but3);
	
	var timerLabel = createText(xmlValue('offerTimer'), {fontSize:22, x:0, y:bg.height*0.885, width:bg.width*0.6});
	firsttimeOfferPopup.addChild(timerLabel);
	var timertext = createText(convertToTime(offer_tim, true), {fontSize:22, color:'#FFCC00', x:0, y:timerLabel.position.y, width:bg.width*0.3});
	timerLabel.anchor.x = timertext.anchor.x = 0;
	firsttimeOfferPopup.addChild(timerLabel);
	firsttimeOfferPopup.addChild(timertext);
	
	var wt = timerLabel.width + 12 + timertext.width;
	timerLabel.position.x = bg.width/2 - wt/2;
	timertext.position.x = timerLabel.position.x + timerLabel.width + 12;

	si = setInterval(function () {
		offer_tim--;
		if (offer_tim<0) {
			offerPurchase = true;
			removeOffer();
			offer_tim = 0;
		}
		updateTxt(timertext, convertToTime(offer_tim, true));
	}, 1000);

	
	function buyPersonalOffer1() {
		numlog('FRO_buy1');
		but1.disable();
		btnAction = offerData.prices[0].btnAction;
		buyOffer();
	}
	function buyPersonalOffer2() {
		numlog('FRO_buy2');
		but2.disable();
		btnAction = offerData.prices[1].btnAction;
		buyOffer();
	}
	function buyPersonalOffer3() {
		numlog('FRO_buy3');
		but3.disable();
		btnAction = offerData.prices[2].btnAction;
		buyOffer();
	}
	
	if (autoplaying) setTimeout(removeOffer, 1000);
	
	animatePopup(firsttimeOfferPopup);
}
function buyOffer() {
	addLoader(); // just add only for 2 sec, while FB dialog appears.
	setTimeout(function () {
		removeLoader();
		
		/*if (levelTime==0 && GAME && kivid && totalTiles>0) {
			tryToBuy = isTournament ? 'externalTimeT' : 'externalTime';
		}*/
		log('1 tryToBuy = '+tryToBuy);
		
		// add processing clip
		moneyPopup = new PIXI.Container();
		moneyPopup.position.y = stageH*0.07;
		drawProcessingClip();
		stage.addChild(moneyPopup);
		//startPingBought();
		
		
	}, 2000);
	offerPurchase = true; // removeloader after purchase...
	ads(btnAction.replace('[quantity]',1)); // if still quantity not defined
}